import { EventArgs, IList$1, Base, Type, IEnumerable$1, Point } from "igniteui-angular-core/ES5/type";
import { IBucketizer } from "./IBucketizer";
import { IFastItemColumn$1 } from "igniteui-angular-core/ES5/IFastItemColumn$1";
import { Series } from "./Series";
import { Rect } from "igniteui-angular-core/ES5/Rect";
import { ScalerParams } from "./ScalerParams";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { IHasCategoryAxis } from "./IHasCategoryAxis";
import { IHasCategoryModePreference } from "./IHasCategoryModePreference";
import { Brush } from "igniteui-angular-core/ES5/Brush";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { HighlightingInfo } from "./HighlightingInfo";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode } from "./CategoryMode";
import { List$1 } from "igniteui-angular-core/ES5/List$1";
import { Dictionary$2 } from "igniteui-angular-core/ES5/Dictionary$2";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { AssigningCategoryStyleEventArgs } from "./AssigningCategoryStyleEventArgs";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { FastItemsSourceEventAction } from "igniteui-angular-core/ES5/FastItemsSourceEventAction";
import { CalculatedColumn } from "./CalculatedColumn";
import { ColumnSupportingCalculation } from "./ColumnSupportingCalculation";
import { RenderSurface } from "./RenderSurface";
import { SupportingCalculation$1 } from "./SupportingCalculation$1";
/**
 * @hidden
 */
export declare class FinancialEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: number, b: number, c: FinancialCalculationDataSource, d: FinancialCalculationSupportingCalculations, e: FinancialSeries);
    private _position;
    position: number;
    private _count;
    count: number;
    private _dataSource;
    dataSource: FinancialCalculationDataSource;
    private _supportingCalculations;
    supportingCalculations: FinancialCalculationSupportingCalculations;
    private _basedOn;
    basedOn: IList$1<string>;
}
/**
 * @hidden
 */
export declare class FinancialBucketCalculator extends Base implements IBucketizer {
    static $t: Type;
    protected a: FinancialSeriesView;
    constructor(a: FinancialSeriesView);
    getBucket(a: number): number[];
    getBucketWithoutUnknowns(a: number): number[];
    getErrorBucket(a: number, b: IFastItemColumn$1<number>): number;
    c: number;
    d: number;
    b: number;
    getBucketInfo(a: number, b: number, c: number, d: number): {
        p0: number;
        p1: number;
        p2: number;
        p3: number;
    };
    e(a: number): void;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare abstract class FinancialSeries extends Series implements IHasCategoryAxis, IHasCategoryModePreference {
    static $t: Type;
    it(a: SeriesView): void;
    mn: FinancialSeriesView;
    protected get_cr(): boolean;
    ag(): Axis[];
    fs(a: any, b: string): any;
    protected n7(): number;
    private n5;
    ah(a: Point): Point[][];
    ai(a: Point): Point[][];
    constructor();
    pd: Brush;
    k8(): Brush;
    ht(): void;
    l7: CategoryAxisBase;
    ms: NumericYAxis;
    on: string;
    m1: IFastItemColumn$1<number>;
    private m0;
    oe: string;
    mx: IFastItemColumn$1<number>;
    private mw;
    oj: string;
    mz: IFastItemColumn$1<number>;
    private my;
    ob: string;
    mv: IFastItemColumn$1<number>;
    private mu;
    or: string;
    m4: IFastItemColumn$1<number>;
    private m3;
    nd: boolean;
    protected m7: boolean;
    assigningCategoryStyle: (sender: any, args: AssigningCategoryStyleEventArgs) => void;
    protected nf(): boolean;
    protected oz(a: AssigningCategoryStyleEventArgs): void;
    protected mf: CategorySeriesRenderManager;
    protected ox(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    nx(a: Point): number;
    fe(a: Point, b: boolean): number;
    fc(a: Point, b: boolean): number;
    d9(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    lk(a: Point, b: boolean, c: boolean): Point;
    en(a: Point, b: boolean, c: boolean): number;
    ej(a: Point, b: boolean, c: boolean): number;
    el(a: Point, b: boolean, c: boolean): number;
    nz(a: Point, b: boolean, c: boolean): number;
    n0(a: Point, b: boolean, c: boolean): number;
    n1(a: Point, b: boolean, c: boolean): number;
    lg(a: Point, b: boolean, c: boolean): Point;
    li(a: Point, b: boolean, c: boolean): Point;
    pf(a: Point, b: boolean, c: boolean): Point;
    pe(a: Point, b: boolean, c: boolean): Point;
    pg(a: Point, b: boolean, c: boolean): Point;
    ia(): void;
    protected js(a: Rect, b: Rect): void;
    protected jr(a: Rect, b: Rect): void;
    protected ni: Dictionary$2<IFastItemColumn$1<number>, string>;
    protected nj: Dictionary$2<string, string>;
    private m2;
    private ow;
    private m6;
    protected iy(a: any, b: string, c: any, d: any): void;
    m9(a: any): boolean;
    m8(a: any): boolean;
    protected l0(a: number, b: number, c: Axis): any[];
    protected n4(a: SeriesView): number;
    protected n6(a: SeriesView): number;
    lz(a: number, b: number): any[];
    private mq;
    protected get_nb(): boolean;
    protected readonly nb: boolean;
    protected get_cv(): boolean;
    at(a: any, b: Point): HighlightingInfo;
    n8(a: Point): number;
    protected mp(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected mo(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected na(): boolean;
    eb(a: Point): number;
    e8(a: Point): number;
    protected get_c1(): boolean;
    ap(): CategoryAxisBase;
    fa(a: Point): number;
    fp(a: Point): any;
    ma: CategoryFrame;
    mc: CategoryFrame;
    l9: CategoryFrame;
    protected ny(a: Rect, b: Rect, c: Rect): number;
    mh: CategoryTransitionInMode;
    ne: boolean;
    protected dc(): boolean;
    protected mg(): CategoryTransitionInMode;
    protected bo(): TransitionInSpeedType;
    o0(a: CategoryFrame, b: FinancialSeriesView): void;
    oy(a: CategoryFrame, b: FinancialSeriesView): void;
    dw(a: Rect, b: Rect, c: SeriesView): boolean;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    mi: CategoryTransitionSourceFramePreparer;
    n2(a: FinancialSeriesView): number;
    protected hw(): void;
    jd(a: boolean): void;
    typical: (sender: any, e: FinancialEventArgs) => void;
    typicalBasedOn: (sender: any, e: FinancialEventArgs) => void;
    protected ng(a: IList$1<string>): boolean;
    readonly nh: boolean;
    protected nc(): boolean;
    protected ov(a: FinancialEventArgs): void;
    protected readonly np: IEnumerable$1<number>;
    private _nm;
    private nm;
    protected readonly no: IEnumerable$1<number>;
    private _nl;
    private nl;
    protected readonly nn: IEnumerable$1<number>;
    private _nk;
    private nk;
    nr(a: IList$1<number>): IList$1<number>;
    private m5;
    protected nq(): IList$1<string>;
    private nv;
    getOpenColumnAsArray(): number[];
    private nt;
    getHighColumnAsArray(): number[];
    private nu;
    getLowColumnAsArray(): number[];
    private ns;
    getCloseColumnAsArray(): number[];
    private nw;
    getVolumeColumnAsArray(): number[];
    protected hy(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected mj(a: number, b: number): FinancialCalculationDataSource;
    n3(a: number): number;
    protected mk(a: FinancialCalculationDataSource): FinancialCalculationSupportingCalculations;
    readonly categoryAxis: CategoryAxisBase;
    private mb;
    je(a: Rect, b: RenderSurface): void;
    private l8;
    jb(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    am(a: Axis): Axis;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    private md;
    me: CategoryMode;
    protected get_cz(): boolean;
    jh(a: Brush, b: Brush): void;
    private o1;
    private mr;
    private mt;
    fr(a: any): any;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class FinancialCalculationSupportingCalculations extends Base {
    static $t: Type;
    a: ColumnSupportingCalculation;
    c: ColumnSupportingCalculation;
    d: ColumnSupportingCalculation;
    b: ColumnSupportingCalculation;
    h: DataSourceSupportingCalculation;
    f: DataSourceSupportingCalculation;
    g: DataSourceSupportingCalculation;
    e: DataSourceSupportingCalculation;
    k: (arg1: (arg1: number) => number, arg2: number, arg3: number) => IEnumerable$1<number>;
    j: (arg1: (arg1: number) => number, arg2: number) => IEnumerable$1<number>;
    i: (arg1: number) => number;
}
/**
 * @hidden
 */
export declare class DataSourceSupportingCalculation extends SupportingCalculation$1<(dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>> {
    static $t: Type;
    constructor(a: number, b: (dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>);
    constructor(a: number, b: (dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>, c: IList$1<string>);
    constructor(a: number, ..._rest: any[]);
}
/**
 * @hidden
 */
export declare class FinancialCalculationDataSource extends Base {
    static $t: Type;
    private _openColumn;
    openColumn: IList$1<number>;
    private _closeColumn;
    closeColumn: IList$1<number>;
    private _highColumn;
    highColumn: IList$1<number>;
    private _lowColumn;
    lowColumn: IList$1<number>;
    private _volumeColumn;
    volumeColumn: IList$1<number>;
    private _indicatorColumn;
    indicatorColumn: IList$1<number>;
    private _typicalColumn;
    typicalColumn: CalculatedColumn;
    private _trueRange;
    trueRange: CalculatedColumn;
    private _trueLow;
    trueLow: CalculatedColumn;
    private _period;
    period: number;
    private _shortPeriod;
    shortPeriod: number;
    private _longPeriod;
    longPeriod: number;
    private _count;
    count: number;
    private _calculateFrom;
    calculateFrom: number;
    private _calculateCount;
    calculateCount: number;
    private _multiplier;
    multiplier: number;
    private _minimumValue;
    minimumValue: number;
    private _maximumValue;
    maximumValue: number;
    private _specifiesRange;
    specifiesRange: boolean;
    private _series;
    series: FinancialSeries;
}
/**
 * @hidden
 */
export declare abstract class FinancialSeriesView extends SeriesView {
    static $t: Type;
    bw: FinancialSeries;
    bu: FinancialBucketCalculator;
    by: number;
    bx(a: CategoryFrame): boolean;
    bz(a: CategoryFrame): void;
    constructor(a: FinancialSeries);
    protected abstract bv(): FinancialBucketCalculator;
    ap(): void;
    getDefaultTooltipTemplate(): string;
    protected ac(): void;
}
