import { Type } from '@angular/core';
import { IgxSplineSeriesBaseComponent } from "./igx-spline-series-base-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { SplineAreaSeries } from "./SplineAreaSeries";
/**
 * Represents a IgxDataChartComponent spline area series.
*
* ````html
* <igx-data-chart
*     [dataSource]="data">
*     <igx-category-x-axis
*         label="label"
*         #xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
*         #yAxis>
*     </igx-numeric-y-axis>
*     <igx-spline-area-series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         valueMemberPath="value">
*     </igx-spline-area-series>
* </igx-data-chart>
* ``
* ```tsx
*  <IgrDataChart
*     dataSource={this.state.dataSource} >
*
*     <IgrNumericXAxis name="xAxis" />
*     <IgrNumericYAxis name="yAxis" />
*
*     <IgrSplineAreaSeries
*      name="series1"
*     xAxisName="xAxis"
* 	yAxisName="yAxis"
* 	valueMemberPath="Value"
* />
*  </IgrDataChart>
* ````
*/
export declare const IgxSplineAreaSeriesComponent_PROVIDERS: ({
    provide: typeof IgxMarkerSeriesComponent;
    useExisting: Type<any>;
} | {
    provide: typeof IgxSeriesComponent;
    useExisting: Type<any>;
})[];
export declare class IgxSplineAreaSeriesComponent extends IgxSplineSeriesBaseComponent {
    protected createImplementation(): SplineAreaSeries;
    /**
                                 * @hidden
                                 */
    readonly i: SplineAreaSeries;
    constructor();
}
